const L: int;
var i: int;

procedure Proc( a: [int]int , b: [int]int ) returns ( rv:bool )
  requires L > 0;
  modifies i;
  ensures ( (forall x:int :: (x >= 0 && x < L) ==> (a[x] == b[x])) <==> rv ) ;
{
  i := 0;
  while ( i < L )
  {
    if ( a[i] != b[i] ) {
      rv := false;
      return;
    }
    i := i+1 ;
  }
  rv := true;
  return;
}
