const L:int;
var a , b : [int]int;
var count, i:int;

procedure Filter ( )
  requires L > 0;
  requires ( forall x:int :: (b[x] == 0) );
  modifies count, i , b;
  // prove that in b there will be only positive elements.
  ensures ( forall x:int :: (0 <= x && x < L) ==> (b[x] >= 0) ); 
{
  count := 0;
  i := 0;
  while ( i < L) {
    if ( a[i] > 0 ) { 
      count := count + 1;
    }
    i := i + 1;
  }

  // here we should have an assertion saying that
  // count = number_of_positive_values_in_a.

  count := 0;
  i := 0;
  while ( i < L) {
    if ( a[i] > 0 ) {
      count := count + 1;
      b[count] := a[i];
    }
    i := i + 1;
  }
}
