type Field;

var Heap: [Field] int;
const unique F: Field;
const unique G: Field;
const F_final: int;
const G_final: int; 


procedure P( )
  modifies Heap;
  requires F_final > 0;
  requires G_final > 0;
  ensures Heap[F] == F_final;
  ensures Heap[G] == G_final; 
{
  Heap[F] := 0;
  Heap[G] := G_final;

  while (Heap[F] < F_final)
  {
    Heap[F] := Heap[F] + 1;
  }
}


